#include <stdio.h>
#include <malloc.h>

double det(double **a,int n)
{
    double **x;
    double ret,sign;
    int i,j,k;
    
    ret=0.0;
    sign=1;

    if ( n==1 ) return a[0][0];

    if ( ! (x=(double **)calloc(n-1,sizeof(double *))) )
      error_exit("Out of Memory",__FILE__,__LINE__);

    for(i=0; i<n; i++) {
      k = 0;
      for(j=0; j<n; j++) {
        if ( i==j ) continue;
          x[k++] = a[j]+1;
        }
        if( a[i][0] != 0.0 )
            ret += sign*a[i][0]*det(x,n-1);
        sign = -sign;
    }
    free(x);
    return ret;
}
