#include "proto.h"

double xyT(double *x,double *y,int n)
{
    int i;
    double ret;

    ret=0.0;
    for(i=0; i<n; i++)
        ret += x[i]*y[i];

    return ret;
}

double **xTy(double *x,double *y,int n)
{
    double **ret;
    int i,j;

    if ( ! (ret=matrix(n,n)) )
        error_exit("Out  of memory",__FILE__,__LINE__);

    for(i=0; i<n; i++)
        for(j=0; j<n; j++)
            ret[i][j] = x[i]*y[j];

    return ret;
}
