#ifndef __PROTO_H
#define __PROTO_H

void   error_exit(char *, char *, int);

double **matrix(int, int);
void   free_matrix(double **, int, int);
double *vector(int);
void   free_vector(double *);
double **sym_matrix(int);
void   free_sym_matrix(double **, int);

void print_vec(double *x,int n);
void print_mat(double **a,int n);
void print_smat(double **a,int n);

double *ax(double **, double *, int);

double xyT(double *, double *, int);
double **xTy(double *, double *, int);

void   scale(double *, double, int);
void   xpay(double *, double, double *, int);
void   axpy(double *, double, double *, int);

double det(double **a,int n);

#endif
