#include <malloc.h>
#include <stdio.h>

double **sym_matrix(int n)
{
    double **mat;
    int i,j;

    mat=(double **)calloc(n,sizeof(double *));
    if (mat) 
      for(i=0; i<n; i++)
        if (! (mat[i]=(double *)calloc(i+1,sizeof(double))) ) {
          for(j=0;j<i;j++) 
            free(mat[i]);
            free(mat);
            mat=(double **)NULL;
            break;
      }

    return mat;
}

void free_sym_matrix(double **mat,int n)
{
    int i;

    for(i=0;i<n;i++) free(mat[i]);
    free(mat);
}
